﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DAL;
using Utility;
using System.Reflection;

namespace ServerHostApp
{
    internal static class Database
    {

        internal static void InitialDatabase()
        {
            using (DataMappingDataContext db = new DataMappingDataContext(true))
            {
                if (!db.DatabaseExists())
                {
                    // create new database
                    db.CreateDatabase();
                    #region///我们不打算支持用户注册，初始化用户
                    User u1 = new User();
                    u1.UserID = "tom";
                    u1.Name = "tom";
                    u1.Password = "tom";

                    User u2 = new User();
                    u2.UserID = "boler";
                    u2.Name = "boler";
                    u2.Password = "boler";

                    User u3 = new User();
                    u3.UserID = "peter";
                    u3.Name = "peter";
                    u3.Password = "peter";

                    User u4 = new User();
                    u4.UserID = "sean";
                    u4.Name = "sean";
                    u4.Password = "sean";

                    User u5 = new User();
                    u5.UserID = "cloudy";
                    u5.Name = "cloudy";
                    u5.Password = "cloudy";

                    db.Users.InsertOnSubmit(u1);
                    db.Users.InsertOnSubmit(u2);
                    db.Users.InsertOnSubmit(u3);
                    db.Users.InsertOnSubmit(u4);
                    db.Users.InsertOnSubmit(u5);
                    #endregion
                    /// 初始化Role
                    foreach (var item in Enum.GetValues(typeof(RoleFlag)))
                    {
                        Role role = new Role();
                        role.RoleID = (int)item;
                        role.Name = item.ToString();
                        db.Roles.InsertOnSubmit(role);
                    }
                    ///初始化gamestatus
                    foreach (var item in Enum.GetValues(typeof(EnumGameStatus)))
                    {
                        GameStatus gamestatus = new GameStatus();
                        gamestatus.StatusID = (int)item;
                        gamestatus.StatusName = item.ToString();
                        db.GameStatus.InsertOnSubmit(gamestatus);
                    }

                    /// 初始化ActivityType
                    foreach (var item in Enum.GetValues(typeof(ActivityTypeFlag)))
                    {
                        ActivityType ac = new ActivityType();
                        ac.ActivityTypeID = (int)item;
                        ac.ActivityTypeName = item.ToString();
                        ac.TimeCollapse = 1;
                        if (item.ToString() == "Vote")
                        {
                            ac.TimeCollapse = 4;
                        }

                        db.ActivityTypes.InsertOnSubmit(ac);
                    }

                    db.SubmitChanges();

                    Console.WriteLine("Create database done!!");
                }
            }
        }
    }
}
